
### Configuration stage
stages:
  - build
  - preprocessing

image: ocaml/opam:ubuntu-18.04-opam

### Configuration section

.build-matrix:
    only: [pushes]
    parallel:
        matrix:
            #- OCAML_VERSION: "4.07.1"
            #- OCAML_VERSION: "4.08.1"
            #- OCAML_VERSION: "4.09.1"
            #- OCAML_VERSION: "4.10.2"
            #- OCAML_VERSION: "4.11.1"
            - OCAML_VERSION: "4.13.1"

preprocessing:
    extends: .build-matrix
    stage: build
    only: [pushes]

    script:
        - echo "--- Pre-processing"
        - sudo apt update
        - sudo apt install --yes wget autoconf

        - echo "--- Pre-processing for OPAM"
        - if [ ! -d _opam ]; then echo "no local switch in the CI cache, we setup a new switch"; opam switch create --yes --no-install . $OCAML_VERSION; fi
        #- opam update
        #- opam upgrade --yes
        - eval $(opam env)

        - echo "--- Installation of DiaLeKto"
        - opam pin --yes add git+https://gitlab.com/semantiko/DiaLeKto
        - opam remove dialekto
        - eval $(opam env)
        - opam update --yes DiaLeKto
        - opam upgrade --yes DiaLeKto
        - eval $(opam env)

        - echo "--- Installation of Alt-ergo dependencies"
        - sudo apt install --yes libgmp-dev m4 pkg-config autoconf zlib1g-dev

        - echo "--- Installation of Lambdapi"
        - opam install --yes dune bindlib timed sedlex menhir pratter yojson cmdliner why3 alcotest alt-ergo odoc lambdapi
        - why3 config detect

        - echo "--- Generate the MM2DK executable"
        - make
        - echo "--- Running tests"
        - make test
        - make local-test

    cache:
         paths:
             - _opam
